CLASSDIR2=classes2
include general.mak

include make/project-CafeBabe.mak
include make/rules-CafeBabe.mak


JARFILE  = CafeBabe.jar
CAFEBABE = org.javalobby.cafebabe.Main

RUNCLASS  = org.javalobby.cafebabe.Main

# string for jar
JAR_FILES = \
	$(PACKAGE3)/*.class  \
	$(PACKAGE4)/*.class \
	$(PACKAGE51)/*.class \
	$(PACKAGE52)/*.class \
	$(PACKAGE53)/*.class \
	$(PACKAGE5)/*.class $(PACKAGE5)/Icons/*.gif

# create output directory
$(CLASSDIR2):
        mkdir $(CLASSDIR2)

UTILLIB:
	@if not exist $(LIBDIR)\Util.jar nmake -f Util.mak jar

SET_CLASSPATH:
        set CLASSPATH=$(LIBDIR)\patch12.jar;$(LIBDIR)\activation.jar;$(CLASSDIR2);$(SRCDIR);$(CLASSPATH)

cleanall: clean
	@if exist $(CLASSDIR2) rmdir /s/q $(CLASSDIR2)
	@if exist $(LIBDIR)\patch12.jar del $(LIBDIR)\patch12.jar
	@if exist $(LIBDIR)\patch13.jar del $(LIBDIR)\patch13.jar
	@if exist $(LIBDIR)\Util.jar del $(LIBDIR)\Util.jar
	@if exist $(LIBDIR)\ClassFile.jar del $(LIBDIR)\ClassFile.jar
	@if exist $(LIBDIR)\SerFile.jar del $(LIBDIR)\SerFile.jar
	@if exist $(LIBDIR)\Task.jar del $(LIBDIR)\Task.jar
	@if exist $(LIBDIR)\CafeBabe.jar del $(LIBDIR)\CafeBabe.jar

	@if exist Plugins\SerPlug.* del Plugins\SerPlug.*
	@if exist Plugins\ClassPlug.* del Plugins\ClassPlug.*
	@if exist Plugins\StripPlug.* del Plugins\StripPlug.*
	@if exist Plugins\CompactPlug.* del Plugins\CompactPlug.*
	@if exist Plugins\ObfuscatePlug.* del Plugins\ObfuscatePlug.*
	@if exist Plugins\MigratePlug.* del Plugins\MigratePlug.*
	@if exist Plugins\HoundPlug.* del Plugins\HoundPlug.*
	@if exist Plugins\HelpPlug.* del Plugins\HelpPlug.*


#compile project
comp: UTILLIB SET_CLASSPATH $(CLASSDIR2) $(CLASSFILES)
	echo $(CLASSPATH)

# run a main class
run:
	start $(JAVA) -Xmx32m -Xincgc -Dos.name=MacWindowsSolaris -Xbootclasspath:$(LIBDIR)\mac.jar;$(LIBDIR)\patch13.jar;$(LIBDIR)\Util.jar;$(LIBDIR)\CafeBabe.jar;$(LIBDIR)\activation.jar;$(CLASSPATH) $(RUNCLASS)

run11:
	start $(JDKHOME11)\bin\java -classpath $(LIBDIR)\CafeBabe.jar;.;$(LIBDIR)\activation.jar;$(LIBDIR)\Util.jar;$(LIBDIR)\mac.jar;$(LIBDIR)\patch12.jar;$(CLASSPATH11) $(RUNCLASS)

run12:
	start $(JDKHOME12)\bin\java -Dos.name=MacWindowsSolaris -Xbootclasspath:$(LIBDIR)\mac.jar;$(LIBDIR)\patch12.jar;$(LIBDIR)\Util.jar;$(LIBDIR)\CafeBabe.jar;$(LIBDIR)\activation.jar;$(CLASSPATH12) $(RUNCLASS)

patch: patch12 patch13

patch12: SET_CLASSPATH
        @if not exist $(LIBDIR)\$(CLASSDIR)\NUL md $(LIBDIR)\$(CLASSDIR)

        $(JAVAC) -d $(LIBDIR)\$(CLASSDIR) $(LIBDIR)\1.2\javax\swing\JFileChooser.java

        cd $(LIBDIR)\$(CLASSDIR)
        $(JAR) cf patch12.jar javax

        cd ..
	@if exist patch12.jar del patch12.jar
        move $(CLASSDIR)\patch12.jar .

!if "$(OS)" == "Windows_NT"
        @if exist $(CLASSDIR)/$(NULL) rmdir /s/q $(CLASSDIR)
!else
        deltree /y $(CLASSDIR)
!endif
        cd ..

patch13:
        set CLASSPATH=$(CLASSDIR);$(LIBDIR);$(CLASSPATH13);$(SWINGHOME)\mac.jar

        @if not exist $(LIBDIR)\$(CLASSDIR)\NUL md $(LIBDIR)\$(CLASSDIR)

        $(JAVAC) -d $(LIBDIR)\$(CLASSDIR) $(LIBDIR)\1.3\javax\swing\JFileChooser.java
        cd $(LIBDIR)\$(CLASSDIR)
        $(JAR) cf patch13.jar javax

        cd ..
	@if exist patch13.jar del patch13.jar
        move $(CLASSDIR)\patch13.jar .

!if "$(OS)" == "Windows_NT"
        @if exist $(CLASSDIR)/$(NULL) rmdir /s/q $(CLASSDIR)
!else
        deltree /y $(CLASSDIR)
!endif
        cd ..

CAFEBABEDIR = org\javalobby\cafebabe

# Create a JAR file
jar: comp
        cd $(CLASSDIR2)
        @if not exist $(CAFEBABEDIR)\Icons mkdir $(CAFEBABEDIR)\Icons
        copy ..\$(SRCDIR)\$(CAFEBABEDIR)\Icons\*.* $(CAFEBABEDIR)\Icons
        $(JAR) cmf << $(JARFILE) $(JAR_FILES)
Main-Class: $(CAFEBABE)
Class-Path: Util.jar
Created-By: $(AUTHOR)
<<
        cd ..
        @if exist $(LIBDIR)\$(JARFILE) del $(LIBDIR)\$(JARFILE)
        move $(CLASSDIR2)\$(JARFILE) $(LIBDIR)

deploy: patch
	nmake -f CafeBabe.mak jar
	nmake -f Plugins.mak jar

!if "$(OS)" == "Windows_NT"
        @if exist Deployment rmdir /s/q Deployment
!else
        deltree /y Deployment
!endif

	@if not exist Deployment\CafeBabe md Deployment\CafeBabe

	@if not exist Deployment\CafeBabe\descriptions md Deployment\CafeBabe\descriptions
	@if not exist Deployment\CafeBabe\doc md Deployment\CafeBabe\doc
	@if not exist Deployment\CafeBabe\Help md Deployment\CafeBabe\Help
	@if not exist Deployment\CafeBabe\$(LIBDIR) md Deployment\CafeBabe\$(LIBDIR)
	@if not exist Deployment\CafeBabe\Plugins md Deployment\CafeBabe\Plugins

        copy bin\*.* Deployment\CafeBabe
        copy descriptions\*.* Deployment\CafeBabe\descriptions
        copy doc\*.* Deployment\CafeBabe\doc
        copy Help\instructions.jar Deployment\CafeBabe\Help
        copy MyTheme.theme Deployment\CafeBabe

        copy $(LIBDIR)\CafeBabe.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\mac.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\activation.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\patch12.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\patch13.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\Util.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\ClassFile.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\SerFile.jar Deployment\CafeBabe\$(LIBDIR)
        copy $(LIBDIR)\Task.jar Deployment\CafeBabe\$(LIBDIR)

        copy Plugins\*.* Deployment\CafeBabe\Plugins

        zip -r -q CafeBabe-sources.zip bin descriptions doc Help src $(LIBDIR)\1.2 \
                                       $(LIBDIR)\1.3 $(LIBDIR)\treetable make org \
                                       Plugins\mailcap.plugins Plugins\mimetypes.plugins \
                                       CafeBabe.mak ClassFile.mak general.mak Makefile \
                                       Plugins.mak SerFile.mak Task.mak Util.mak MyTheme.theme

        move CafeBabe-sources.zip Deployment

        cd Deployment
        zip -r -q CafeBabe.zip CafeBabe
        cd ..

# run a main class from jar
jarrun:
        $(JAVA2) -Xbootclasspath:$(BOOTCLASSPATH) -jar $(JARFILE)

jarrun11:
        SET CLASSPATH=$(CLASSPATH);$(JARFILE)
        $(JAVA) $(RUNCLASS)


zipsrc :
        zip -r CafeBabe-sources.zip bat doc Icons $(LIBDIR) org CafeBabe.java Makefile.cafebabe manifest.cafebabe


$(DOC):
        mkdir $(DOC)
        $(JAVADOC) -author -version -verbose -d $(DOC) -sourcepath $(PACKAGE2)\*
