include general.mak

include make/project-Plugins.mak
include make/rules-Plugins.mak

PLUGINSDIR   = Plugins

JAR_FILE1 = SerPlug.cba
JAR_FILE2 = ClassPlug.cba
JAR_FILE3 = StripPlug.cba
JAR_FILE4 = MigratePlug.cba
JAR_FILE5 = ObfuscatePlug.cba
JAR_FILE6 = CompactPlug.cba
JAR_FILE7 = HoundPlug.cba

# string for jar
JAR_FILES1 = \
	$(PACKAGE11)/*.class $(PACKAGE11)/Icons/*.gif

JAR_FILES2 = \
	$(PACKAGE21)/*.class \
	$(PACKAGE22)/*.class \
	$(PACKAGE23)/*.class \
	$(PACKAGE24)/*.class \
	$(PACKAGE25)/*.class $(PACKAGE25)/Icons/*.gif \
	treetable/*.class  \

JAR_FILES3 = \
	$(PACKAGE31)/*.class $(PACKAGE31)/Icons/*.gif

JAR_FILES4 = \
	$(PACKAGE41)/*.class $(PACKAGE41)/Icons/*.gif

JAR_FILES5 = \
	$(PACKAGE51)/*.class $(PACKAGE51)/Icons/*.gif

JAR_FILES6 = \
	$(PACKAGE61)/*.class $(PACKAGE61)/Icons/*.gif

JAR_FILES7 = \
	$(PACKAGE71)/*.class \
	$(PACKAGE72)/*.class $(PACKAGE72)/Icons/*.gif \

CLASSFILELIB:
	@if not exist $(LIBDIR)\ClassFile.jar nmake -f ClassFile.mak jar

SERFILELIB:
	@if not exist $(LIBDIR)\SerFile.jar nmake -f SerFile.mak jar

TASKLIB:
	@if not exist $(LIBDIR)\Task.jar nmake -f Task.mak jar

SET_CLASSPATH1:
        set CLASSPATH=$(LIBDIR)\patch12.jar;$(SRCDIR);$(CLASSDIR);$(CLASSPATH);$(LIBDIR)\ClassFile.jar;$(LIBDIR)\SerFile.jar;$(LIBDIR)\activation.jar;$(LIBDIR)\CafeBabe.jar

SET_CLASSPATH2:
        set CLASSPATH=$(LIBDIR)\patch12.jar;$(SRCDIR);$(CLASSDIR);$(CLASSPATH);$(LIBDIR);$(LIBDIR)\ClassFile.jar;$(LIBDIR)\activation.jar;$(LIBDIR)\CafeBabe.jar

SET_CLASSPATH3:
        set CLASSPATH=$(LIBDIR)\patch12.jar;$(SRCDIR);$(CLASSDIR);$(CLASSPATH);$(LIBDIR);$(LIBDIR)\ClassFile.jar;$(LIBDIR)\Task.jar;$(LIBDIR)\activation.jar;$(LIBDIR)\CafeBabe.jar

#compile project
comp1: SERFILELIB SET_CLASSPATH1 $(CLASSDIR) $(CLASSFILES1)

comp2: CLASSFILELIB SET_CLASSPATH2 $(CLASSDIR) $(CLASSFILES2)

comp3: TASKLIB SET_CLASSPATH3 $(CLASSDIR) $(CLASSFILES3)

comp4: TASKLIB SET_CLASSPATH3 $(CLASSDIR) $(CLASSFILES4)

comp5: TASKLIB SET_CLASSPATH3 $(CLASSDIR) $(CLASSFILES5)

comp6: TASKLIB SET_CLASSPATH3 $(CLASSDIR) $(CLASSFILES6)

comp7: CLASSFILELIB SET_CLASSPATH2 $(CLASSDIR) $(CLASSFILES7)


jar: serplug classplug stripplug migrateplug obfplug compactplug houndplug


SERPLUGDIR = org\javalobby\cafebabe\plugin\serplug
CLASSPLUGDIR = org\javalobby\cafebabe\plugin\classplug
STRIPPLUGDIR = org\javalobby\cafebabe\plugin\stripplug
MIGRATEPLUGDIR = org\javalobby\cafebabe\plugin\migrateplug
OBFPLUGDIR = org\javalobby\cafebabe\plugin\obfplug
COMPACTPLUGDIR = org\javalobby\cafebabe\plugin\compactplug
HOUNDPLUGDIR = org\javalobby\cafebabe\plugin\houndplug

serplug: comp1
	cd $(CLASSDIR)
        @if not exist $(SERPLUGDIR)\Icons mkdir $(SERPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(SERPLUGDIR)\Icons\*.* $(SERPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE1) $(JAR_FILES1)
Main-Class: org.javalobby.cafebabe.plugin.serplug.SerFrame
Class-Path: lib/ClassFile.jar, lib/SerFile.jar
Created-By: $(AUTHOR)
Extension: ser
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE1) del $(PLUGINSDIR)\$(JAR_FILE1)
        move $(CLASSDIR)\$(JAR_FILE1) $(PLUGINSDIR)

classplug: comp2
	cd $(CLASSDIR)
        @if not exist $(CLASSPLUGDIR)\Icons mkdir $(CLASSPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(CLASSPLUGDIR)\Icons\*.* $(CLASSPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE2) $(JAR_FILES2)
Main-Class: org.javalobby.cafebabe.plugin.classplug.ClassFrame
Class-Path: lib/ClassFile.jar
Created-By: $(AUTHOR)
Extension: class
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE2) del $(PLUGINSDIR)\$(JAR_FILE2)
        move $(CLASSDIR)\$(JAR_FILE2) $(PLUGINSDIR)

stripplug: comp3
	cd $(CLASSDIR)
        @if not exist $(STRIPPLUGDIR)\Icons mkdir $(STRIPPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(STRIPPLUGDIR)\Icons\*.* $(STRIPPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE3) $(JAR_FILES3)
Main-Class: org.javalobby.cafebabe.plugin.stripplug.StripFrame
Action: Strip
Description: Strip group of files
Icon: org/javalobby/cafebabe/plugin/stripplug/Icons/strip.gif
Class-Path: lib/ClassFile.jar, lib/Task.jar
Created-By: $(AUTHOR)
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE3) del $(PLUGINSDIR)\$(JAR_FILE3)
        move $(CLASSDIR)\$(JAR_FILE3) $(PLUGINSDIR)

migrateplug: comp4
	cd $(CLASSDIR)
        @if not exist $(MIGRATEPLUGDIR)\Icons mkdir $(MIGRATEPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(MIGRATEPLUGDIR)\Icons\*.* $(MIGRATEPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE4) $(JAR_FILES4)
Main-Class: org.javalobby.cafebabe.plugin.migrateplug.MigrateFrame
Action: Migrate
Description: Migrate group of files
Icon: org/javalobby/cafebabe/plugin/migrateplug/Icons/migrate.gif
Class-Path: lib/ClassFile.jar, lib/Task.jar
Created-By: $(AUTHOR)
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE4) del $(PLUGINSDIR)\$(JAR_FILE4)
        move $(CLASSDIR)\$(JAR_FILE4) $(PLUGINSDIR)

obfplug: comp5
	cd $(CLASSDIR)
        @if not exist $(OBFPLUGDIR)\Icons mkdir $(OBFPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(OBFPLUGDIR)\Icons\*.* $(OBFPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE5) $(JAR_FILES5)
Main-Class: org.javalobby.cafebabe.plugin.obfplug.ObfuscateFrame
Action: Obfuscate
Description: Obfuscate group of files
Icon: org/javalobby/cafebabe/plugin/obfplug/Icons/obfuscate.gif
Class-Path: lib/ClassFile.jar, lib/Task.jar
Created-By: $(AUTHOR)
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE5) del $(PLUGINSDIR)\$(JAR_FILE5)
        move $(CLASSDIR)\$(JAR_FILE5) $(PLUGINSDIR)

compactplug: comp6
	cd $(CLASSDIR)
        @if not exist $(COMPACTPLUGDIR)\Icons mkdir $(COMPACTPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(COMPACTPLUGDIR)\Icons\*.* $(COMPACTPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE6) $(JAR_FILES6)
Main-Class: org.javalobby.cafebabe.plugin.compactplug.CompactFrame
Action: Compact (Dietolog)
Description: Compact group of files
Icon: org/javalobby/cafebabe/plugin/compactplug/Icons/compact.gif
Class-Path: lib/ClassFile.jar, lib/Task.jar
Created-By: $(AUTHOR)
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE6) del $(PLUGINSDIR)\$(JAR_FILE6)
        move $(CLASSDIR)\$(JAR_FILE6) $(PLUGINSDIR)

houndplug: comp7
	cd $(CLASSDIR)
        @if not exist $(HOUNDPLUGDIR)\Icons mkdir $(HOUNDPLUGDIR)\Icons
        copy ..\$(SRCDIR)\$(HOUNDPLUGDIR)\Icons\*.* $(HOUNDPLUGDIR)\Icons
        $(JAR) cmf << $(JAR_FILE7) $(JAR_FILES7)
Main-Class: org.javalobby.cafebabe.plugin.houndplug.ClassHoundFrame
Action: Class-Hound Service
Description: Quick navigation among accesible class files
Icon: org/javalobby/cafebabe/plugin/houndplug/Icons/hound.gif
Class-Path: lib/ClassFile.jar
Created-By: $(AUTHOR)
<<
	cd ..

        @if exist $(PLUGINSDIR)\$(JAR_FILE7) del $(PLUGINSDIR)\$(JAR_FILE7)
        move $(CLASSDIR)\$(JAR_FILE7) $(PLUGINSDIR)

