include general.mak

include make/project-Task.mak
include make/rules-Task.mak


S_JARFILE    = Stripper.jar
M_JARFILE    = Migrator.jar
D_JARFILE    = Dietolog.jar
O_JARFILE    = Obfuscator.jar

JARFILE      = Task.jar

STRIPPER   = org.javalobby.task.Stripper
MIGRATOR   = org.javalobby.task.Migrator
DIETOLOG   = org.javalobby.task.Dietolog
OBFUSCATOR = org.javalobby.task.Obfuscator

RUNCLASS  = org.javalobby.task.IntegrityChecker Test/WebBroker2.class

#RUNCLASS  = org.javalobby.task.TemplateGroupTask classes log.txt true
#RUNCLASS  = org.javalobby.util.ZipClassLoader
#RUNCLASS  = org.javalobby.task.Stripper Result Result2
#RUNCLASS  = org.javalobby.task.Migrator
#RUNCLASS  = org.javalobby.task.Dietolog  descriptions\cafebabe.cmp
#RUNCLASS  = org.javalobby.task.Obfuscator descriptions\task1.obf

# string for jar
JAR_FILES = \
	$(PACKAGE21)/*.class \
	$(PACKAGE22)/*.class \
	$(PACKAGE23)/*.class \
	$(PACKAGE24)/*.class \
	$(PACKAGE25)/*.class \
	$(PACKAGE26)/*.class \
	$(PACKAGE27)/*.class \
	$(PACKAGE28)/*.class \
	$(PACKAGE2)/*.class

CLASSFILELIB:
	@if not exist $(LIBDIR)\ClassFile.jar nmake -f ClassFile.mak jar

UTILLIB:
	@if not exist $(LIBDIR)\Util.jar nmake -f Util.mak jar

SET_CLASSPATH:
        set CLASSPATH=$(SRCDIR);$(CLASSDIR);$(CLASSPATH);$(LIBDIR)\ClassFile.jar;$(LIBDIR)\Util.jar

#compile project
comp: UTILLIB CLASSFILELIB SET_CLASSPATH $(CLASSDIR) $(CLASSFILES)

# run a main class
run: comp
        $(JAVA) $(RUNCLASS)

jar: comp
        cd $(CLASSDIR)
        $(JAR) cmf << $(JARFILE) $(JAR_FILES)
Class-Path: .\lib\Util.jar, .\lib\ClassFile.jar
Created-By: $(AUTHOR)
<<
        cd ..
        @if exist $(LIBDIR)\$(JARFILE) del $(LIBDIR)\$(JARFILE)
        move $(CLASSDIR)\$(JARFILE) $(LIBDIR)

s_jar: clean SET_CLASSPATH $(CLASSDIR)
        $(JAVAC) -d $(CLASSDIR) org\javalobby\task\Stripper.java
        cd $(CLASSDIR)
        $(JAR) cmf << $(S_JARFILE) $(JAR_FILES)
Main-Class: $(STRIPPER)
Class-Path: $(S_JARFILE)
Created-By: $(AUTHOR)
<<
        cd ..

m_jar: clean SET_CLASSPATH $(CLASSDIR)
        $(JAVAC) -d $(CLASSDIR) org\javalobby\task\Migrator.java
        cd $(CLASSDIR)
        $(JAR) cmf << $(M_JARFILE) $(JAR_FILES)
Main-Class: $(MIGRATOR)
Class-Path: $(M_JARFILE)
Created-By: $(AUTHOR)
<<
        cd ..

d_jar: clean SET_CLASSPATH $(CLASSDIR)
        $(JAVAC) -d $(CLASSDIR) org\javalobby\task\Dietolog.java
        cd $(CLASSDIR)
        $(JAR) cmf << $(D_JARFILE) $(JAR_FILES)
Main-Class: $(MIGRATOR)
Class-Path: $(D_JARFILE)
Created-By: $(AUTHOR)
<<
        cd ..

o_jar: clean SET_CLASSPATH $(CLASSDIR)
        $(JAVAC) -d $(CLASSDIR) org\javalobby\task\Obfuscator.java
        cd $(CLASSDIR)
        $(JAR) cmf << $(O_JARFILE) $(JAR_FILES)
Main-Class: $(OBFUSCATOR)
Class-Path: $(O_JARFILE)
Created-By: $(AUTHOR)
<<
        cd ..
