# general part of make process

.SUFFIXES: .java .class .jar .mf .xml

JFLAGS =
#-g -deprecation -O -Djava.compiler=NONE

# common user variables

CLASSDIR = classes
LIBDIR   = lib
SRCDIR   = src
DOC      = doc
AUTHOR   = Alexander Shvets

# system variables

# JDK 1.0.2 setup (Sun)
JDKHOME102   = d:\jdk1.0.2
CLASSPATH102 = $(JDKHOME102)\lib\classes.zip
JAVAC102     = $(JDKHOME102)\bin\javac.exe


# JDK 1.1 setup (Sun)
JDKHOME11   = d:\jdk1.1
SWINGHOME   = d:\swing
CLASSPATH11 = $(JDKHOME11)\lib\classes.zip;$(SWINGHOME)\swingall.jar
JAVAC11     = d:\arc\sj.exe
#JAVAC11       = $(JDKHOME11)\bin\javac.exe

# JDK 1.1 setup (IBM)

# JDK 1.2 setup (Sun)
JDKHOME12     = d:\jdk1.2
CLASSPATH12   = $(JDKHOME12)\jre\lib\rt.jar;$(JDKHOME12)\jre\lib\i18n.jar
BOOTCLASSPATH = .;$(JDKHOME12)\jre\lib\rt.jar;$(JDKHOME12)\jre\lib\i18n.jar
JAVAC12       = d:\arc\sJ.exe
#JAVAC12       = $(JDKHOME12)\bin\javac.exe

# JDK 1.3 setup (Sun)
JDKHOME13     = d:\jdk1.3
CLASSPATH13   = $(JDKHOME13)\jre\lib\rt.jar;$(JDKHOME13)\jre\lib\i18n.jar
BOOTCLASSPATH = .;$(JDKHOME13)\jre\lib\rt.jar;$(JDKHOME13)\jre\lib\i18n.jar
JAVAC13       = d:\arc\sj.exe
#JAVAC13       = d:\arc\jikes.exe

# set the default to 1.1

JDKHOME   = $(JDKHOME13)
CLASSPATH = $(CLASSPATH13)
JAVAC     = $(JAVAC13) $(JFLAGS)

JAVA      = $(JDKHOME)\bin\java.exe
JAR       = $(JDKHOME)\bin\jar.exe
JAVADOC   = $(JDKHOME)\bin\javadoc.exe

# get version of JDK
ver:
        $(JAVA) -version

# get CLASSPATH
cp:
        @echo $(CLASSPATH)

# create output directory
$(CLASSDIR):
        mkdir $(CLASSDIR)

clean: FORCE
!if "$(OS)" == "Windows_NT"
        @if exist $(CLASSDIR)/$(NULL) rmdir /s/q $(CLASSDIR)
!else
        deltree /y $(CLASSDIR)
!endif

FORCE:
