// DescriptionChooser.java

package org.javalobby.cafebabe;

import java.io.*;

import javax.swing.*;

public class DescriptionChooser {

  private static String extension;
  private static String description;

  private static JFileChooser fileChooser = new JFileChooser(".");
  private static DescriptionFilter filter = new DescriptionFilter();

  private DescriptionChooser() {}

  public static JFileChooser getInstance(String ext, String descr) {
    if(ext.equals(extension) && descr.equals(description))
      return fileChooser;

    extension   = ext;
    description = descr;

    fileChooser.resetChoosableFileFilters();

    fileChooser.setFileFilter(filter);
    fileChooser.addChoosableFileFilter(filter);

    return fileChooser;
  }

  public static File getCurrentDirectory() {
    return fileChooser.getCurrentDirectory();
  }

  public static void setCurrentDirectory(File dir) {
    fileChooser.setCurrentDirectory(dir);
  }

static class DescriptionFilter extends javax.swing.filechooser.FileFilter {

  public String getDescription() {
    return description;
  }

  public boolean accept(File f) {
    if(f != null) {
      if(f.isDirectory())
        return true;

      if(f.getName().endsWith(extension))
        return true;
    }
    return false;
  }
}


}
