// ClassFileChooser.java

package org.javalobby.cafebabe;

import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.filechooser.*;

import org.javalobby.util.*;
import org.javalobby.cafebabe.archooser.*;

public class ProgramChooser extends ArchiveChooser {

  private static ProgramChooser instance = new ProgramChooser();

  private ProgramFrame programFrame;

  private ProgramChooser() {
    super();

    setFileView(new ProgramFileView());
  }

  public void setProgramFrame(ProgramFrame programFrame) {
    this.programFrame = programFrame;
  }

  public static ProgramChooser getInstance() {
    if(instance == null) {
      instance = new ProgramChooser();
    }

    return instance;
  }

/*  public void openFile() {
    File f = null;

    this.rescanCurrentDirectory();
    int returnVal = this.showDialog(this, "Open file");
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      f = getSelectedFile();
    }

    if(f != null && !f.isDirectory()) {
      programFrame.open(f.getAbsolutePath());
    }
  }

  public void openFile(File file) {
    programFrame.open(file.getAbsolutePath());
  }
*/

  public void openFile() {
    File f = openChooser("Open file");

    if(f != null && !f.isDirectory()) {
      openFile(f);
    }
  }

  public void openFile(File file) {
    programFrame.open(file);
  }

  public File openChooser(String title) {
    this.rescanCurrentDirectory();
    int returnVal = this.showDialog(this, title);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      return this.getSelectedFile();
    }

    return null;
  }

}

