// ArchivedDataSource.java

package org.javalobby.cafebabe.activation;

import java.io.*;
import java.util.zip.*;

import javax.activation.*;


public class ArchivedDataSource implements DataSource {

  private ZipFile zipFile;
  private ZipEntry zipEntry;

  public ArchivedDataSource(ZipFile zipFile, String zipEntryName) {
    this.zipFile  = zipFile;
    this.zipEntry = zipFile.getEntry(zipEntryName);
  }

  public InputStream getInputStream() throws IOException {
    return zipFile.getInputStream(zipEntry);
  }

  public OutputStream getOutputStream() throws IOException {
    throw new IOException("This operation doesn't supported for an archive.");
  }

  public String getContentType() {
    return FileTypeMap.getDefaultFileTypeMap().getContentType(zipEntry.getName());
  }

  public String getName() {
    return zipEntry.getName();
  }

}
