package org.javalobby.cafebabe.activation;

import java.io.*;
import java.awt.*;

import javax.swing.*;
import javax.activation.*;

public class TextViewer extends JPanel implements CommandObject {
  protected JTextArea textArea;
  protected DataHandler dataHandler;

  public TextViewer() {
    setLayout(new GridLayout(1, 1));

    textArea = new JTextArea();
    textArea.setEditable(false);

    add(new JScrollPane(textArea));
  }

  public void setCommandContext(String s, DataHandler dataHandler) throws IOException {
    this.dataHandler = dataHandler;

    setInputStream(dataHandler.getInputStream());
  }

  public void setInputStream(InputStream is) throws IOException {
    int i = 0;
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    byte abyte0[] = new byte[1024];

    while((i = is.read(abyte0)) > 0) {
      baos.write(abyte0, 0, i);
    }

    is.close();

    textArea.setText(baos.toString());
  }

  public void addNotify() {
    super.addNotify();

    invalidate();
  }

  public Dimension getPreferredSize() {
    return textArea.getMinimumSize();
  }

}
