// ArchiveChooser.java

package org.javalobby.cafebabe.archooser;

import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.filechooser.*;

import org.javalobby.util.*;
import org.javalobby.cafebabe.archooser.*;

public class ArchiveChooser extends JFileChooser {

  public ArchiveChooser() {
    super(new ArchiveFileSystemView());

    setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

    File file = null;
    try {
      file = new File(new File(".").getCanonicalPath());
    }
    catch(Exception e) {
      file = new File(".");
    }

    setSelectedFile(file);
    setCurrentDirectory(file);

    setAcceptAllFileFilterUsed(false);

    addChoosableFileFilter(getAcceptAllFileFilter());
    addChoosableFileFilter(new ArchiveFileFilter());

    setFileFilter(getAcceptAllFileFilter());
  }

  public File openChooser(String title) {
    this.rescanCurrentDirectory();

    int returnVal = this.showDialog(this, title);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      return this.getSelectedFile();
    }

    return null;
  }

}

