// ArchiveFileSystemView.java

package org.javalobby.cafebabe.archooser;

import java.io.*;
import java.util.*;
import java.util.zip.*;
import javax.swing.*;
import javax.swing.filechooser.*;

public class ArchiveFileSystemView extends FileSystemView {

  private FileSystemView currentFileSystemView =
                         FileSystemView.getFileSystemView();

  public boolean isRoot(File f) {
    return currentFileSystemView.isRoot(f);
  }

  public File createNewFolder(File containingDir) throws IOException {
    return currentFileSystemView.createNewFolder(containingDir);
  }

  public boolean isHiddenFile(File f) {
    return currentFileSystemView.isHiddenFile(f);
  }

  public File[] getRoots() {
    return currentFileSystemView.getRoots();
  }

  public File createFileObject(File dir, String filename) {
    if(dir == null)
      return new File(filename);

    if(dir instanceof ArchivedFile) {
      ArchivedFile ef = (ArchivedFile)dir;

      ArchivedFile efi = new ArchivedFile(ef, filename);
      return efi;
/*      try {
        ArchivedFile efi = new ArchivedFile(ef, filename);
        return efi;
      }
      catch(Exception e) { e.printStackTrace(); }
*/
    }

    return new File(dir, filename);
  }

  public File createFileObject(String path) {
    String path1 = path.toLowerCase();
    int pos = path1.indexOf(".zip");
    if(pos == -1)
      pos = path1.indexOf(".jar");

    if(pos != -1) {
      try {
        String zipName = path.substring(0, pos+4);

        int pos1 = (path.length() > pos+4+1) ? pos+4+1 : path.length();
        String entryName = path.substring(pos1);
        File f = null;
        if(entryName.length() == 0) {
          f = new ArchivedFile(zipName);
        }
        else {
          if(entryName.endsWith("/")) {
            f = new ArchivedFile(zipName, entryName);
          }
          else {
            f = new ArchivedFile(zipName, entryName + "/");
          }
        }

        return f;
      }
      catch(Exception e) { e.printStackTrace(); }
    }

    File f = new File(path);

    return f;
  }

  public File getParentDirectory(File dir) {
    if(dir != null) {
      File f = createFileObject(dir.getAbsolutePath());
      String parentFilename = f.getParent();
      if(parentFilename != null) {
        // IT'S WORK FOR JEFF!!!
//      return new File(parentFilename);
        return createFileObject(parentFilename);
      }
    }

    return null;
  }

}
