// EditUtfDialog.java

package org.javalobby.cafebabe.plugin.classplug;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

// dialog that assists constant pool's entry edition

public class EditUtfDialog extends JDialog {

  private String utfString;

  public EditUtfDialog(JFrame parentFrame, String utf) {
    // Make sure we call the parent
    super(parentFrame, true);

    enableEvents(AWTEvent.FOCUS_EVENT_MASK);

    this.getContentPane().setLayout(new BorderLayout());

    this.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) { utfString = null; }
    });

    // Set the characteristics for this dialog instance
    this.setTitle("Edit UTF string...");
    this.setResizable(false);
    Rectangle r = parentFrame.getBounds();
    this.setBounds(r.x + r.width/2 - 300, r.y + r.height/2 - 90/2, 200, 90);

    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

    // Create a panel for the components
    JPanel topPanel = new JPanel();

    this.getContentPane().add(topPanel, BorderLayout.CENTER);

    final JTextField input = new JTextField(48);
    input.setText(utf);

    JButton okButton = new JButton("Ok");
    okButton.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        utfString = input.getText();
        EditUtfDialog.this.dispose();
      }
    });

    JButton cancelButton = new JButton("Cancel");
    cancelButton.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        utfString = null;
        EditUtfDialog.this.dispose();
      }
    });

    topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.Y_AXIS));
    topPanel.add(new JLabel("UTF string to edit: "));
    topPanel.add(input);
    topPanel.add(okButton);
    topPanel.add(cancelButton);
    pack();

    input.requestFocus();
  }

  public String getUtfString() { return utfString; }

}
