// BodyEditorActions.java

package org.javalobby.cafebabe.plugin.classplug.bodyeditor;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import org.javalobby.util.*;

import org.javalobby.cafebabe.*;
import org.javalobby.cafebabe.plugin.classplug.*;

public class BodyEditorActions extends Actions implements ClassPlugConstants {

  private Action editAction, addAction, removeAction, helpAction;

  protected JToolBar toolBar = new JToolBar();

  private BodyEditor parent;

  public BodyEditorActions(BodyEditor parent) {
    this.parent = parent;

    init();
  }

  public JToolBar getToolBar() {
    return toolBar;
  }

  private void init() {
    editAction    = createEditAction("Edit instruction",
                               IconProducer.getImageIcon(ICON_EDIT));
    addAction     = createAddAction("Add instruction",
                               IconProducer.getImageIcon(ICON_ADD));
    removeAction  =  createRemoveAction("Remove instructions",
                               IconProducer.getImageIcon(ICON_REMOVE));
    helpAction    =  createHelpAction("Help",
                               IconProducer.getImageIcon(Constants.ICON_TUTORIAL_OFF));

    addActionToToolBar(editAction, toolBar, false, "Edit instruction", 0);
    addActionToToolBar(addAction, toolBar, false, "Add instruction", 0);
    addActionToToolBar(removeAction, toolBar, false, "Remove instruction", 0);

    JPanel emptyArea = new JPanel();
    toolBar.add(emptyArea);

    addActionToToolBar(helpAction, toolBar, false, "Help", 0);
  }

  public Action createEditAction(String text, ImageIcon icon) {
    return new AbstractAction(text, icon) {
      public void actionPerformed(ActionEvent e) {
        parent.editInstruction();
      }
    };
  }

  public Action createAddAction(String text, ImageIcon icon) {
    return new AbstractAction(text, icon) {
      public void actionPerformed(ActionEvent e) {
        parent.addInstruction();
      }
    };
  }

  public Action createRemoveAction(String text, ImageIcon icon) {
    return new AbstractAction(text, icon) {
      public void actionPerformed(ActionEvent e) {
        parent.removeInstructions();
      }
    };
  }

  public Action createHelpAction(String text, ImageIcon icon) {
    return new AbstractAction(text, icon) {
      public void actionPerformed(ActionEvent e) {
        parent.help();
      }
    };
  }

}
