// MnemonicsModel.java

package org.javalobby.cafebabe.plugin.classplug.bodyeditor;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;

import org.javalobby.classfile.instruction.*;

public class MnemonicsModel extends AbstractListModel {

  private int[] opcodes = new int[0];

  public MnemonicsModel() {}

  public void setOpcodes(int[] opcodes) {
    this.opcodes = opcodes;

    fireContentsChanged(this, 0, opcodes.length-1);
  }

  public int getSize() {
    return opcodes.length;
  }

  public Object getElementAt(int index) {
    if(index >= 0 && index < opcodes.length)
      return getOperation(index);
    else
      return null;
  }

  private String getOperation(int index) {
    return OpcodeTable.getDescription((byte)opcodes[index]).mnemonic;
  }

}
