// HelpFrame.java

package org.javalobby.cafebabe.plugin.classplug.help;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import org.javalobby.cafebabe.*;


public class HelpFrame extends PluginFrame {
  private HelpViewer helpViewer;

  public HelpFrame() {
    super();

    setTitle("Help System");

    helpViewer = new HelpViewer();

    this.getContentPane().add(helpViewer);
  }

  public void open() {
    // Set the characteristics for this dialog instance
    Rectangle r = this.getDesktopPane().getBounds();
    this.setBounds(r.x + r.width/2 - 650/2, r.y + r.height/2 - 500/2, 650, 450);

    super.open();
  }

  public void showTopic(String instructionsArchive, String topic) {
    helpViewer.updateHistory("jar:file:" + instructionsArchive + "!/" + topic);
  }

  public void showTopic(String topic) {
    helpViewer.updateHistory("file:" + topic);
  }

}
