// HelpTreeModel.java

package org.javalobby.cafebabe.plugin.classplug.help;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;

public class HelpTreeModel extends DefaultTreeModel {

  private final static String ROOT_TITLE = "Help";
  private RootNode root;

  public HelpTreeModel() {
    super(new RootNode(ROOT_TITLE));

    root = (RootNode)getRoot();
  }

  public DefaultMutableTreeNode getTopicNode(String topic) {
    return getTopicNode(root, topic);
  }

  private DefaultMutableTreeNode getTopicNode(TreeNode parent, String topic) {
    int cnt = getChildCount(parent);

    for(int i=0; i < cnt; i++) {
      DefaultMutableTreeNode topicNode =
                    (DefaultMutableTreeNode)getChild(parent, i);
      if(topicNode.getAllowsChildren()) {
        return getTopicNode(topicNode, topic);
      }
      else {
        HelpLeafNode leaf = (HelpLeafNode)topicNode;
        String reference = leaf.getReference();
        if(reference.equals(topic))
          return topicNode;
      }
    }

    return null;
  }

}
