// MigrationRulesModel.java

package org.javalobby.cafebabe.plugin.migrateplug;

import java.util.*;

import javax.swing.*;
import javax.swing.table.*;

public class MigrationRulesModel extends AbstractTableModel {

  final static String[] names = {"From", "To"};
  final static Vector data = new Vector();

  public Vector getData() { return data; }

  public int getColumnCount() { return names.length; }

  public int getRowCount() { return data.size(); }

  public Object getValueAt(int row, int column) {
    String line = (String)data.elementAt(row);
    int pos = line.indexOf(':');
    if(column == 0) return line.substring(0, pos);
    else            return line.substring(pos+1);
  }

  public String getColumnName(int column) {
    return names[column];
  }

  public Class getColumnClass(int c) {
    return getValueAt(0, c).getClass();
  }

  public boolean isCellEditable(int row, int column) { return true; }

  public void setValueAt(Object aValue, int row, int column) {
    aValue = ((String)aValue).replace('.', '/');
    String line = (String)data.elementAt(row);
    int pos = line.indexOf(':');
    String first  = line.substring(0, pos);
    String second = line.substring(pos+1);

    if(column == 0)
      data.setElementAt(aValue.toString() + ':' + second, row);
    else
      data.setElementAt(first + ':' + aValue, row);
  }

}
