// DeniedListModel.java

package org.javalobby.cafebabe.plugin.obfplug;

import java.util.*;

import javax.swing.*;
import javax.swing.table.*;

public class DeniedListModel extends AbstractTableModel {

  final static String[] names = {"Class name"};
  final static Vector data = new Vector();

  public Vector getData() { return data; }

  public int getColumnCount() { return names.length; }

  public int getRowCount() { return data.size(); }

  public Object getValueAt(int row, int column) {
    return data.elementAt(row);
  }

  public String getColumnName(int column) {
    return names[column];
  }

  public Class getColumnClass(int c) {
    return getValueAt(0, c).getClass();
  }

  public boolean isCellEditable(int row, int column) { return true; }

  public void setValueAt(Object aValue, int row, int column) {
    aValue = ((String)aValue).replace('.', '/');
    data.setElementAt(aValue, row);
  }

}
