// BytesProducer.java

package org.javalobby.classfile;

import java.util.*;
import java.io.*;

/**
 * This is only a container for static methods
 *
 * @version 1.0 02/22/2000
 * @author Alexander Shvets
 */
public final class BytesProducer {

  /* Doesn't allow create any instance of this class */
  private BytesProducer() {}

  /**
   * Convert an entry int an array of bytes.
   *
   * @param entry input entry for conversion
   * @return an entry in form of array
   */
  public static byte[] getBytes(Entry entry) {
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    DataOutputStream dos       = new DataOutputStream(baos);

    try {
      entry.write(dos);
      dos.close();
    }
    catch(IOException e) {
      e.printStackTrace();
    }

    return baos.toByteArray();
  }

}
