// PoolEntry.java

package org.javalobby.classfile;

import java.io.*;

/**
 * Basic interface for any entry that will be inserted into constant pool.
 *
 * @version 1.0 02/22/2000
 * @author Alexander Shvets
 */
public interface ConstPoolEntry extends PoolEntry {

  /** A constant for presentation of UTF8 entry */
  public static final byte CONSTANT_UTF8            = 1;

  /** A constant for presentation of Unicode entry */
  public static final byte CONSTANT_UNICODE         = 2;

  /** A constant for presentation of Integer entry */
  public static final byte CONSTANT_INTEGER         = 3;

  /** A constant for presentation of Float entry */
  public static final byte CONSTANT_FLOAT           = 4;

  /** A constant for presentation of Long entry */
  public static final byte CONSTANT_LONG            = 5;

  /** A constant for presentation of Double entry */
  public static final byte CONSTANT_DOUBLE          = 6;

  /** A constant for presentation of Class entry */
  public static final byte CONSTANT_CLASS           = 7;

  /** A constant for presentation of String entry */
  public static final byte CONSTANT_STRING          = 8;

  /** A constant for presentation of Field entry */
  public static final byte CONSTANT_FIELD           = 9;

  /** A constant for presentation of Method entry */
  public static final byte CONSTANT_METHOD          = 10;

  /** A constant for presentation of Interface Method entry */
  public static final byte CONSTANT_INTERFACEMETHOD = 11;

  /** A constant for presentation of Name and Type entry */
  public static final byte CONSTANT_NAMEANDTYPE     = 12;

}
