// FieldConst.java

package org.javalobby.classfile;

import java.io.*;

/**
 * Class that represents a "field" const entry.
 *
 * @version 1.0 02/22/2000
 * @author Alexander Shvets
 */
public class FieldConst extends MemberConst {

  /**
   * The default constructor that creates field constant.
   */
  public FieldConst() {}

  /**
   * Get type of this entry.
   *
   * @return  type of entry
   */
  public String getType() {
    return "Field Const";
  }

  /**
   * Get tag of this entry.
   *
   * @return  tag for entry
   */
  public byte getTag() {
    return CONSTANT_FIELD;
  }

  /**
   * Compares two Objects for equality. Two field consts
   * will be equals if they both have the same value-array.
   *
   * @param   object  the reference object with which to compare.
   * @return  true if this object is the same as the obj
   *          argument; false otherwise.
   */
  public boolean equals(Object o) {
    if(o == null) return false;

    if(o instanceof FieldConst) {
      FieldConst c = (FieldConst)o;
      return ((nameIndex == c.nameIndex) && (valueIndex == c.valueIndex));
    }

    return false;
  }

}
