// Resolvable.java

package org.javalobby.classfile;

import java.io.*;

/**
 * This interface define that an entry with implemented Resolvable
 * interface can be resolved on base of information that contain
 * specified pool.
 *
 * @version 1.0 02/22/2000
 * @author Alexander Shvets
 */
public interface Resolvable {

  /**
   * Resolve this entry.
   *
   * @param   pool  pool that contain an entry that implements this
   * interface and corresponding information for resolving process
   * @return  an array of string that contains all resolved information
   */
  public String[] resolve(Pool pool);

}
