// Instruction.java


package org.javalobby.classfile.instruction;

import org.javalobby.classfile.*;

/**
 * This interface represents instruction behavoir. An instruction is
 * a single entry inside method body.
 *
 * @version 1.0 02/22/2000
 * @author Alexander Shvets
 */
public interface Instruction extends TagEntry, Resolvable {

  /**
   * Get a mnemonic
   *
   * @return a mnemonic for this instruction
   */
  public String getMnemonic();

  /**
   * Get a parameter in form of a byte array. This information occupies
   * a place after first byte of instruction (tag). If command has
   * a length = 1, then this parameter is null.
   *
   * @return a parameter in form of a byte array
   */
  public byte[] getParameter();

  /**
   * Check is this instruction is wide
   *
   * @return true if is this instruction is wide; false otherwise
   */
  public boolean isWide();

}
