// MdiMenuBar.java

package org.javalobby.mdi;

import javax.swing.*;

public class MdiMenuBar extends JMenuBar {

  protected JMenu windowMenu = new JMenu("Window");

  public MdiMenuBar() {
    super();
  }

  public JMenuItem addWindowMenuItem(String windowName) {
    JMenuItem menuItem = null;

    int pos = findWindowMenuItem(windowName);
    if(pos == -1) {
      menuItem = new JMenuItem(windowName);
      windowMenu.add(menuItem);
    }
    else {
      menuItem = windowMenu.getItem(pos);
    }

    return menuItem;
  }

  public void removeWindowMenuItem(String windowName) {
    int pos = findWindowMenuItem(windowName);

    if(pos >= 0) {
      windowMenu.remove(pos);
    }
  }

  private int findWindowMenuItem(String windowName) {

    int cnt = windowMenu.getMenuComponentCount();

    for(int i=0; i < cnt; i++) {
      JMenuItem item = windowMenu.getItem(i);
      if(item != null) {
        String name = item.getActionCommand();
        if(name.equals(windowName))
          return i;
      }
    }

    return -1;
  }


  public JMenu getWindowMenu() { return windowMenu; }

}
