// Annotation.java

package org.javalobby.serfile;

import java.io.*;

import org.javalobby.classfile.*;

/*
 * Class that is used for holding class or object annotation.
 *
 * Annotation: TC_ENDBLOCKDATA | (contents endBlockData)
 * // contents written by annotateClass or writeObject or writeExternal PROTOCOL_VERSION_2
 *
 * @version 1.0 05/25/2000
 * @author Alexander Shvets
 */
public class Annotation extends PlainCollection {

  /**
   * Creates an annotation that can hold only elements of generic type.
   *
   * @param handlesTable  table of handles
   */
  public Annotation(String type, HandlesTable handlesTable) {
    super(Entry.class, type, handlesTable);
  }

  /**
   * Read annotation from input stream.
   *
   * @param  in  input stream.
   * @exception  IOException if an I/O error occurs.
   */
  public void read(DataInput in) throws IOException {
    while(true) {
      byte tag = in.readByte();

      ContentEntry entry = new ContentEntry(tag, handlesTable);
      entry.read(in);

      entries.addElement(entry);

      if(tag == SerConstants.TC_ENDBLOCKDATA) {
        break;
      }
    }
  }

}
