// ProxyClassDescSerEntry.java

package org.javalobby.serfile;

import java.io.*;

/**
 * Class that represents a proxy class description entry.
 *
 * @version 1.0 05/25/2000
 * @author Alexander Shvets
 */
public class ProxyClassDescSerEntry extends HandleSerEntry {

  /**
   * Read this entry from input stream.
   *
   * @param  in  input stream.
   * @exception  IOException if an I/O error occurs.
   */
  public void read(DataInput in) throws IOException  {
    handle = 0;
    throw new IOException("Not implemented yet");
  }

  /**
   * Write this entry to output stream.
   *
   * @param  out  output stream.
   * @exception  IOException if an I/O error occurs.
   */
  public void write(DataOutput out) throws IOException {
    out.writeByte(getTag());

    throw new IOException("Not implemented yet");
  }

  /**
   * Get type of this entry.
   *
   * @return  type of entry
   */
  public String getType() {
    return "Proxy Class Description";
  }

  /**
   * Length of this entry in bytes.
   *
   * @return  length of entry
   */
  public long length() {
    return 1;
  }

  /**
   * Get tag of this entry.
   *
   * @return  tag for entry
   */
  public byte getTag() {
    return TC_PROXYCLASSDESC;
  }

  /**
   * Returns a string representation of the object.
   *
   * @return  a string representation of the object.
   */
  public String toString() {
    return getType() ;
  }

}
