// IntegrityChecker.java

package org.javalobby.task;

import java.io.*;
//import java.util.*;

import org.javalobby.classfile.*;
//import org.javalobby.classfile.attribute.*;
//import org.javalobby.classfile.instruction.*;

import org.javalobby.task.event.*;
import org.javalobby.task.integrity.*;

public class IntegrityChecker implements NotificationListener {
  private Integrity integrity;

  public IntegrityChecker(String classFileName) throws IOException {
    ClassFile classFile = new ClassFile();
    classFile.read(classFileName);

    integrity = new Integrity(classFile);

    integrity.addNotificationListener(this);
  }

  public void notification(NotificationEvent event) {
    System.out.println("  " + event.getNotification() +
                       " " + event.getDescription());
  }

  public void check() {
    integrity.check();
  }

  public static void main(String[] args) throws IOException {
    String classFileName = null;

    try {
      classFileName = args[0];
    }
    catch(Exception e) {
      System.out.println("\nUsage: java org.javalobby.task.IntegrityChecker classFileName");
      System.out.println("Author : " + Constants.AUTHOR);
      System.out.println("e-mail : " + Constants.EMAIL);
      return;
    }

    IntegrityChecker integrityChecker = new IntegrityChecker(classFileName);

    integrityChecker.check();
  }

}
