// Migrator.java

package org.javalobby.task;

import java.io.*;

import org.javalobby.classfile.*;
import org.javalobby.task.basic.*;
import org.javalobby.task.event.*;
import org.javalobby.task.migrator.*;

// An example for batch processing of Strip-task
public class Migrator extends GroupTask implements NotificationListener {

  public Migrator(Task task, String from, boolean recursively) {
    super(task, from, recursively);

    this.addNotificationListener(this);
    task.addNotificationListener(this);
  }

  public void notification(NotificationEvent event) {
    System.out.println("  " + event.getNotification() +
                       " " + event.getDescription());
  }

  public static void main(String[] argv) {
    String tableFileName = null;
    String from = null, to = null;
    boolean recursively  = true;
    try {
      tableFileName = argv[0];
      from          = new File(argv[1]).getPath();
      to            = new File(argv[2]).getPath();
    }
    catch(Exception e) {
      System.out.println("\nUsage: java org.javalobby.task.Migrator migrationTable from to [recursively]");
      System.out.println("where migrationTable is file with rules;");
      System.out.println("      from, to are directory or archive;");
      System.out.println("      recursively is boolean\n");
      System.out.println("Author : " + Constants.AUTHOR);
      System.out.println("e-mail : " + Constants.EMAIL);
      return;
    }

    try {
      recursively = Boolean.valueOf(argv[3]).booleanValue();
    }
    catch(ArrayIndexOutOfBoundsException e) {}
    catch(Exception e) {
      System.out.println("Error in parameter [recursively] ");
    }

    MigrateTask task = new MigrateTask(tableFileName, to);

/*    MigrateTask task = null;
    try {
      task = new MigrateTask(tableFileName, to);
    }
    catch(Exception e2) {
      System.out.println("Error in Migration Table's file");
      return;
    }
*/
    GroupTask groupTask = new Migrator(task, from, recursively);

    try {
      System.out.println("Migration group command started...\n");

      groupTask.processing();

      System.out.println("Migration group command finished...\n");

      System.out.println(groupTask.getProcessedFiles() + " files processed.");
      System.out.println(groupTask.getMovements() + " movements occured.");
      System.out.println(groupTask.getReplacements() + " replacements occured.");
    }
    catch(Exception e) {
      System.out.println(e);
    }
  }

}
