// Stripper.java

package org.javalobby.task;

import java.io.*;

import org.javalobby.classfile.*;
import org.javalobby.task.basic.*;
import org.javalobby.task.event.*;
import org.javalobby.task.stripper.*;

// An example for batch processing of Strip-task
public class Stripper extends GroupTask
                              implements NotificationListener {

  public Stripper(Task task, String from, boolean recursive) {
    super(task, from, recursive);

    this.addNotificationListener(this);
    task.addNotificationListener(this);
  }

  public void notification(NotificationEvent event) {
    System.out.println("  " + event.getNotification() +
                       " " + event.getDescription());
  }

  public static void main(String[] argv) {
    String from = null;
    String to   = null;
    boolean recursively = true;
    try {
      from = new File(argv[0]).getPath();
      to   = new File(argv[1]).getPath();
    }
    catch(Exception e) {
      System.out.println("\nUsage: java org.javalobby.task.Stripper from To [recursively]");
      System.out.println("Where from, to are directory or archive;");
      System.out.println("      recursively is boolean\n");
      System.out.println("Author : " + Constants.AUTHOR);
      System.out.println("e-mail : " + Constants.EMAIL);
      return;
    }

    try {
      recursively = Boolean.valueOf(argv[2]).booleanValue();
    }
    catch(Exception e) {}

    StripTask task = new StripTask(to, new boolean[] {true, true, true});

    GroupTask groupTask = new Stripper(task, from, recursively);

    try {
      System.out.println("Strip group command started...\n");

      groupTask.processing();

      System.out.println("Strip group command finished...\n");

      System.out.println(groupTask.getProcessedFiles() + " files processed.");
      System.out.println(groupTask.getReplacements() + " replacements occured.");
    }
    catch(Exception e) {
      System.out.println(e);
    }
  }

}
