// Bounds.java

package org.javalobby.task.compactor;

import java.util.*;

public abstract class Bounds {

  protected String[] bounds = new String[0];

  public Bounds() {}

  public void setBounds(String[] bounds) {
    this.bounds = bounds;
  }

  public void setBounds(String s) {
    if(s == null) s = "";
    this.bounds = split(s);
  }

  public String[] getBounds() {
    return bounds;
  }

  protected static String[] split(String s) {
    StringTokenizer st = new StringTokenizer(s);
    String[] r = new String[st.countTokens()];

    for(int i=0; st.hasMoreTokens(); i++) {
      r[i] = st.nextToken();
    }

    return r;
  }

  public abstract boolean contains(String name);

  public Enumeration entries() {
    return new Enumeration() {
      private int cnt = 0;
      public boolean hasMoreElements() { return cnt < bounds.length; }
      public Object nextElement()      { return bounds[cnt++]; }
    };
  }

}
