// ClasspathBounds.java

package org.javalobby.task.compactor;

import java.io.*;

public class ClasspathBounds extends Bounds {

  public static final String DEFAULT_BOUNDS;
  static {
    String stdLib = System.getProperty("java.home") + File.separator;
    if(System.getProperty("java.version").startsWith("1.2"))
      stdLib = stdLib + "jre" + File.separator + "lib" +
               File.separator + "rt.jar";
    else
      stdLib = stdLib + "lib" + File.separator + "classes.zip";

    try {
      stdLib = new File(stdLib).getCanonicalPath();
    }
    catch (IOException e2) {}

    DEFAULT_BOUNDS = stdLib.replace(File.separatorChar, '/');
  }

  public ClasspathBounds() {}

/*  public void setBounds(String s) {
    if(s == null)
      s = DEFAULT_BOUNDS;

    super.setBounds(s);
  }
*/

  public boolean contains(String name) {
    if(bounds != null) {
      for(int i=0; i < bounds.length; i++)
        if(bounds[i].replace('\\', '/').equalsIgnoreCase(name))
          return true;
    }
    return false;
  }

}
