// DependenciesFinder.java

package org.javalobby.task.compactor;

import java.io.*;
import java.util.*;

import org.javalobby.task.compactor.*;
import org.javalobby.task.event.*;
import org.javalobby.task.util.*;

public abstract class DependenciesFinder {

  private NotificationSupport support = new NotificationSupport(this);

  static protected CustomClassPath classPathVariable;

  protected ClasspathBounds classpathBounds  = new ClasspathBounds();
  protected PackagesBounds packagesBounds    = new PackagesBounds();

  protected Vector classesList = new Vector();
  protected Vector dllList     = new Vector();

  public DependenciesFinder(String classPath) {
    classPathVariable = new CustomClassPath(classPath);
  }

  public abstract void analyze(String startName);

  public Vector getDllList() { return dllList; }

  public Vector getFoundedClasses() { return classesList; }

  public void setClasspathBounds(String classpathEntries) {
    classpathBounds.setBounds(classpathEntries);
  }

  public void setPackagesBounds(String packages) {
    packagesBounds.setBounds(packages);
  }

  // show classpath entries
  public void showClasspath() {

    System.out.println("\nElements of CLASSPATH:\n");
    Enumeration elements = classPathVariable.elements();
    while(elements.hasMoreElements())
      System.out.println((String)elements.nextElement());

    System.out.println();

    // show classpath bounds
    System.out.println("Disabled CLASSPATH entries:");

    Enumeration classpathEntries = classpathBounds.entries();
    while(classpathEntries.hasMoreElements())
      System.out.println((String)classpathEntries.nextElement());

    System.out.println();

    // show packages bounds
    System.out.println("Disabled packages:");

    Enumeration packagesEntries = packagesBounds.entries();
    while(packagesEntries.hasMoreElements())
      System.out.println((String)packagesEntries.nextElement());

    System.out.println();
  }

  public synchronized void addNotificationListener(NotificationListener l) {
    support.addNotificationListener(l);
  }
  public synchronized void removeNotificationListener(NotificationListener l) {
    support.removeNotificationListener(l);
  }

  // fire NotificationEvent to registered listeners
  protected void fireNotification(String notification, String description) {
    support.fireNotification(notification, description);
  }

}
