// MethodFinder.java

package org.javalobby.task.compactor;

import java.io.*;
import java.util.*;

import org.javalobby.task.compactor.*;
import org.javalobby.task.*;
import org.javalobby.task.event.*;
import org.javalobby.task.util.*;

public class MethodFinder extends DependenciesFinder {

  private Vector methodsList           = new Vector();
  private Vector discoveredMethodsList = new Vector();
  private CompactTask2 task;

  protected String outputDir;
//  protected Archiver archiver;
//  protected Copier copier;

  public MethodFinder(String classPath, String outputDir/*,
                      Archiver archiver, Copier copier*/) {
    super(classPath);

    this.outputDir = outputDir;
//    this.archiver  = archiver;
//    this.copier    = copier;

    task = new CompactTask2(classPath, classesList, methodsList,
                      discoveredMethodsList, dllList, packagesBounds);
  }

  public void analyze(String className) {
    task.tryAddMethod(className + ".main([Ljava/lang/String;)V");
    task.tryAddClass(className);

    copyFiles();

    int pos = 0;  // pos1 - number of discovered methods
    int pos2 = 0; // pos2 - number of extracted/copied files
    while(true) {
  //    pos2 = collectFiles(pos2);
      findNewFiles(pos);

      if(discoveredMethodsList.size() == 0)
        break;

      pos = methodsList.size();

      copyFiles();

      System.out.println("Number of founded classes = " + classesList.size());
      System.out.println("Number of founded methods = " + methodsList.size());
    }
  }

/*  private int collectFiles(int pos) {
    Enumeration e = classPathVariable.elements();

    int index = pos;
    while(e.hasMoreElements() && (index < classesList.size())) {

      String name = (String)e.nextElement();
      name = name.replace('\\', '/');

      if(classpathBounds.contains(name)) continue;

      File fileEntry = new File(name);
      if(!fileEntry.isDirectory()) {
        fireNotification(name, "Seek in archive");
        index += archiver.unzip(classesList, pos, name, outputDir);
      }
      else {
        fireNotification(name, "Seek in directory");
        index += copier.copy(classesList, pos, name, outputDir);
      }
    }

    return index;
  }
*/

  public void findNewFiles(int analyzedPoint) {

    if((methodsList.size() == 0) || (methodsList == null))
      return;

    if(analyzedPoint >= methodsList.size())
      return;

    for(int i=analyzedPoint; i < methodsList.size(); i++) {
      String item = (String)methodsList.elementAt(i);

      int pos = item.lastIndexOf(".");

      String className  = item.substring(0, pos);
      String methodName = item.substring(pos+1);
      String classFileName = outputDir.replace('\\', '/') + "/" +
                             className.replace('.', '/') + ".class";
      try {
        fireNotification(item, "Analyzing method");
        task.solve(classFileName, methodName);
      }
      catch (FileNotFoundException e1) {
        fireNotification("", "File " + classFileName + " does not found.");
        continue;
      }
      catch (Exception e2) {
        fireNotification("", e2 + " when analyzing " + classFileName + ".");
        e2.printStackTrace();
        continue;
      }
    }
  }

  private void copyFiles() {
    for(int i=0; i < discoveredMethodsList.size(); i++) {
      String name = (String)discoveredMethodsList.elementAt(i);
      methodsList.addElement(name);
    }

    discoveredMethodsList.removeAllElements();
  }

  public Vector getFoundedMethods() { return methodsList; }

}
