// NameGenerator.java

package org.javalobby.task.obfuscator;

import java.util.*;

public class NameGenerator {
  final static char DUMMY = '$';

  private static char lettersTable[] = {
    DUMMY, 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k',
    'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
    'w', 'x', 'y', 'z'
  };

  Vector excludesList = new Vector();

  private int BASE = lettersTable.length;

  private int lastNameCode = 0;

  // algorithm for conversion code to name is based on conversion
  // to number system on base lettersTable.length:
  // currentNameCode is divided th lettersTable.length while it doen't equals 0.
  // Result is concatenation of partial remainder in reverse order

  public NameGenerator() {}

  public String getNewName() {
    String newName = null;

    if(lastNameCode < BASE)
      newName = new String(new char[] { lettersTable[lastNameCode] });
    else {
      StringBuffer sb = new StringBuffer();

      int tempNumber = lastNameCode;
      while(tempNumber > 0) {
        int remainder = tempNumber % BASE;
        sb.insert(0, lettersTable[remainder]);

        tempNumber /= BASE;
      }

      newName = sb.toString();
    }

    lastNameCode++;

    if(newName.indexOf(DUMMY) != -1 || excludesList.contains(newName))
      return getNewName();

    return newName;
  }

  public void clear() {
    lastNameCode = 0;
  }

  public void setSeed(int startCode) {
    lastNameCode = startCode;
  }

  public void excludeName(String name) {
    if(!excludesList.contains(name))
      excludesList.addElement(name);
  }

  public static void main(String[] argv) {
    NameGenerator gen = new NameGenerator();
    gen.excludeName("aa");
    gen.excludeName("c");
    gen.excludeName("abc");

    for(int i=0; i < 1000; i++) {
      System.out.println(gen.getNewName());
    }
  }

}
