// CustomClassPath.java

package org.javalobby.task.util;

import java.io.*;
import java.util.*;

// a class for splitting entries from CLASSPATH,
// removing double and incorrect entries,
// sorting alpabetically

public class CustomClassPath {

  private Vector entries = new Vector();

  public CustomClassPath() {
    split(System.getProperty("java.class.path"));
  }

  public CustomClassPath(String classPath) {
    split(classPath);
  }

  public void addEntry(String entry) {
    if(!entries.contains(entry))
      entries.addElement(entry);
  }

  public void removeEntry(String entry) {
    entries.removeElement(entry);
  }

  private void split(String classPath) {
    StringTokenizer st = new StringTokenizer(classPath, File.pathSeparator);
    while(st.hasMoreTokens()) {
      String entryName = (String)st.nextToken();
      File fileEntry = new File(entryName);
      if(!fileEntry.exists())
        continue;

      String name = null;
      try {
        name = fileEntry.getCanonicalPath();
        if(!entries.contains(name)) {
          entries.addElement(name);
        }
      }
      catch (IOException e2) {
        System.out.println(e2);
      }
    }
  }

  // first directories then archives
  private void sort() {
    Vector zipList = new Vector();
    int cnt = 0;
    while(cnt < entries.size()) {
      String item = (String)entries.elementAt(cnt);

      File f = new File(item);

      if(!f.isDirectory()) {
        entries.removeElement(item);
        zipList.addElement(item);
      }
      else
        cnt++;
    }

    for(int i=0; i < zipList.size(); i++) {
       entries.addElement(zipList.elementAt(i));
    }

//    sort();
  }

  public Enumeration elements() {
    return entries.elements();
  }

  public static void main(String[] args) {
//    String classPath = "d:\\jdk1.1\\lib\\classes.zip;d:\\swing\\swingall.jar;.;classes";
    String classPath = System.getProperty("java.class.path");

    CustomClassPath envVar = new CustomClassPath(classPath);

    Enumeration e = envVar.elements();
    while(e.hasMoreElements())
      System.out.println((String)e.nextElement());
  }

}

