// OneToManyTable.java

package org.javalobby.task.util;

import java.util.*;

public class OneToManyTable {

  protected Hashtable table = new Hashtable();

  public OneToManyTable() {}

  public ManyElement put(Object one, Object fromManyValue) {
    ManyElement element = createManyElement(fromManyValue);
    return put(one, element);
  }

  public ManyElement put(Object one, ManyElement element) {
    if(table.containsKey(one)) {
      ManyContainer c = (ManyContainer)table.get(one);
      return c.put(element);
    }
    else {
      ManyContainer c = createManyContainer();
      table.put(one, c);
      return c.put(element);
    }
  }

  public void put(Object one, ManyContainer container) {
    table.put(one, container);
  }

  public ManyElement get(Object one, Object fromManyValue) {
    if(table.containsKey(one)) {
      ManyContainer c = (ManyContainer)table.get(one);
      Enumeration e = c.elements();
      while(e.hasMoreElements()) {
        ManyElement element = (ManyElement)e.nextElement();
        if(element.getValue().equals(fromManyValue))
          return element;
      }
    }

    return null;
  }

  public ManyContainer get(Object one) {
    return (ManyContainer)table.get(one);
  }

  public boolean contains(Object one, Object fromManyValue) {
    return get(one, fromManyValue) != null;
  }

  public boolean contains(Object one) {
    return table.containsKey(one);
  }

  public ManyContainer createManyContainer() {
    return new DefaultManyContainer();
  }

  public ManyElement createManyElement(Object value) {
    return new DefaultManyElement(value);
  }

  public void remove(Object one) {
    table.remove(one);
  }

  public Enumeration ones() {
    return table.keys();
  }

  public Enumeration many(Object one) {
    ManyContainer c = (ManyContainer)table.get(one);
    if(c != null)
      return c.elements();

    return createManyContainer().elements();
  }

  public OneToManyTable reverse() {
    OneToManyTable tmpTable = new OneToManyTable();
    Enumeration e = this.ones();
    while(e.hasMoreElements()) {
      Object one = e.nextElement();
      Enumeration e2 = this.many(one);
      while(e2.hasMoreElements()) {
        ManyElement element = (ManyElement)e2.nextElement();
        tmpTable.put(element.getValue(), createManyElement(one));
      }
    }

    return tmpTable;
  }

  public Object clone() {
    OneToManyTable t = new OneToManyTable();
    t.table = (Hashtable)table.clone();

    return t;
  }

  public void print() {
    Enumeration e = this.ones();
    while(e.hasMoreElements()) {
      String one = (String)e.nextElement();
      System.out.println(one + ":");
      Enumeration e2 = this.many(one);
      while(e2.hasMoreElements()) {
        ManyElement element = (ManyElement)e2.nextElement();
        System.out.println("   " + element);
      }
      System.out.println();
    }
  }


  public static void main(String[] argv) {
    OneToManyTable table1 = new OneToManyTable();

    table1.put("a1", "b1");
    table1.put("a1", "b2");
    table1.put("a1", "b2");

    table1.put("a2", "c1");
    table1.put("a2", "b1");

    table1.print();

    OneToManyTable table2 = (OneToManyTable)table1.clone();

    table2.remove("a2");
    System.out.println("Table1:");
    table1.print();

    System.out.println("Table2:");
    table2.print();

    System.out.println("Reversed table:");
    table1.reverse().print();

    if(table1.contains("a1", "b1"))
      System.out.println("table1 contains a1-b1");
    else
      System.out.println("table1 doesn't contain a1-b1");

    if(table1.contains("a1", "b5"))
      System.out.println("table1 contains a1-b5");
    else
      System.out.println("table1 doesn't contain a1-b5");


/*    OneToManyTable table2 = new OneToManyTable();
    Name n = new Name("some");
    table2.put("a1", n);
    table2.put("b1", n);
    table2.print();
    n.setSecond("other");
    table2.print();

    Name n2 = (Name)table2.get("b1", "some");
    n2.setSecond("ughh!");
    table2.print();
*/
  }


}

/*class Name extends Pair implements ManyElement {

  public Name(Object first) { super(first); }

  public Object getValue() { return getFirst(); }

}
*/