// PairsTable.java

package org.javalobby.task.util;

import java.util.*;

public class PairsTable {

  protected Vector list = new Vector();

  public PairsTable() {}

  public void put(Object first) {
    int i = find(first);
    if(i == -1)
      list.addElement(new Pair(first));
    else {
      list.setElementAt(new Pair(first), i);
    }
  }

  public void put(Object first, Object second) {
    put(new Pair(first, second));
  }

  public void put(Pair pair) {
    int i = find(pair);
    if(i == -1)
      list.addElement(pair);
    else
      list.setElementAt(pair, i);
  }

  public void exclude(Pair pair) {
    exclude(pair.getFirst());
  }

  public void exclude(Object first) {
    int i = find(first);
    if(i != -1)
      list.removeElementAt(i);
  }

  public boolean contains(Object first) {
    for(int i=0 ; i < list.size(); i++) {
      Object f = ((Pair)list.elementAt(i)).getFirst();
      if(f.equals(first))
        return true;
    }

    return false;
  }

  public boolean contains(Object first, Object second) {
    for(int i=0 ; i < list.size(); i++) {
      Object f = ((Pair)list.elementAt(i)).getFirst();
      Object s = ((Pair)list.elementAt(i)).getSecond();
      if(f.equals(first) && s.equals(second))
        return true;
    }

    return false;
  }


  public int find(Object first) {
    return find(first, true);
  }

  public int find(Object first, boolean exact) {
    for(int i=0 ; i < list.size(); i++) {
      Object f = ((Pair)list.elementAt(i)).getFirst();
      if(exact) {
        if(f.equals(first))
          return i;
      }
      else {
        if(f.toString().startsWith(first.toString()))
          return i;
      }
    }

    return -1;
  }

  public int find(Pair pair) {
    for(int i=0 ; i < list.size(); i++) {
      Pair p = (Pair)list.elementAt(i);
      if(p.getFirst().equals(pair.getFirst()) &&
         p.getSecond().equals(pair.getSecond()))
        return i;
    }

    return -1;
  }

  public Pair get(Object first) {
    return get(first, true);
  }

  public Pair get(Object first, boolean exact) {
    int pos = find(first, exact);
    if(pos != -1)
      return (Pair)list.elementAt(pos);

    return null;
  }

  public void remove(Pair pair) {
    int i = find(pair);
    if(i != -1)
      list.removeElementAt(i);
  }

  public Enumeration elements() {
    return list.elements();
  }

  public int size() {
    return list.size();
  }

  public Object clone() {
    PairsTable t = new PairsTable();
    t.list = (Vector)list.clone();

    return t;
  }

  public void sort() {
    int i = list.size();
    boolean flag = true;
    while(flag) {
      flag = false;
      for(int k = 0; k < i - 1; k++) {
        Pair el1 = (Pair)list.elementAt(k);
        Pair el2 = (Pair)list.elementAt(k + 1);
        if(el1.getFirst().toString().compareTo(el2.getFirst().toString()) > 0) {
          Pair pair = (Pair)list.elementAt(k + 1);
          list.removeElementAt(k + 1);
          list.insertElementAt(pair, k);
          flag = true;
        }
      }
    }
  }

  public static void main(String[] argv) {
    PairsTable table = new PairsTable();
    table.put("a1", "b1");
    table.put("a1", "b2");

    table.put("a2", "c1");
//    table.put("a2", "");

    System.out.println("table.get() " + table.get("a2").getSecond().getClass().getName());

    Enumeration e = table.elements();
    while(e.hasMoreElements()) {
      System.out.println(e.nextElement());
    }

    table.remove(new Pair("a2", "c1"));

    e = table.elements();
    while(e.hasMoreElements()) {
      System.out.println(e.nextElement());
    }
  }

}
