// SinglesTable.java

package org.javalobby.task.util;

import java.util.*;

public class SinglesTable {

  Vector list = new Vector();

  public SinglesTable() {}

  public void put(Object value) {
    put(new Single(value));
  }

  public void put(Single single) {
    int i = find(single.getValue());
    if(i == -1)
      list.addElement(single);
    else
      list.setElementAt(single, i);
  }

  public void exclude(Single single) {
    exclude(single.getValue());
  }

  public void exclude(Object value) {
    int i = find(value);
    if(i != -1)
      list.removeElementAt(i);
  }

  public boolean contains(Object value) {
    for(int i=0 ; i < list.size(); i++) {
      Object v = ((Single)list.elementAt(i)).getValue();
      if(v.equals(value))
        return true;
    }

    return false;
  }

  public int find(Object value) {
    return find(value, true);
  }

  public int find(Object value, boolean exact) {
    for(int i=0 ; i < list.size(); i++) {
      Object v = ((Single)list.elementAt(i)).getValue();
      if(exact) {
        if(v.equals(value))
          return i;
      }
      else {
        if(v.toString().startsWith(value.toString()))
          return i;
      }
    }

    return -1;
  }

  public Single get(Object value) {
    return get(value, true);
  }

  public Single get(Object value, boolean exact) {
    int pos = find(value, exact);
    if(pos != -1)
      return (Single)list.elementAt(pos);

    return null;
  }

  public Enumeration elements() {
    return list.elements();
  }

  public int size() {
    return list.size();
  }

  public Object clone() {
    SinglesTable t = new SinglesTable();
    t.list = (Vector)list.clone();

    return t;
  }

  public static void main(String[] argv) {
    SinglesTable table = new SinglesTable();
    table.put("a1");
    table.put("a2");

    table.put("c1");
    table.put("a1");
    table.put("");
    table.put("a3");
    Enumeration e = table.elements();
    while(e.hasMoreElements()) {
      System.out.println(e.nextElement());
    }
    System.out.println("size " + table.size());

    if(table.contains("a2"))
      System.out.println("table contains a2");

    if(!table.contains("a10"))
      System.out.println("table doesn't contain a10");

    table.exclude("a1");
    if(table.contains("a1"))
      System.out.println("table contains a1 after excluding");
    else
      System.out.println("table doesn't contain a1 after excluding");

    e = table.elements();
    while(e.hasMoreElements()) {
      System.out.println(e.nextElement());
    }
    System.out.println("size " + table.size());

  }

}
