// IconProducer.class

package org.javalobby.util;

import java.io.*;
import java.net.URL;
import java.awt.*;
import javax.swing.*;

// this class correctly find icon for 1.1 and 1.2,
// inside compressed archive or current directory

public class IconProducer {

//  static String archiveName;

  static boolean isJava2Version = false, archiveExists = false;

  static {
    String version = System.getProperty("java.version");
    if(version.startsWith("1.2") || version.startsWith("1.3"))
      isJava2Version = true;
  }

/*  public static void setArchive(String name) {
    archiveName = name;
    archiveExists = new File(archiveName).exists();
  }
*/

  public static ImageIcon getImageIcon(String iconFileName) {
    return getImageIcon(iconFileName, Object.class);
  }

  public static ImageIcon getImageIcon(String iconFileName, Class clazz) {
    InputStream is = null;

    if(clazz.getClassLoader() == null) {
      is = clazz.getClass().getResourceAsStream(iconFileName);
    }
    else {
      is = (clazz.getClassLoader()).getResourceAsStream(iconFileName);
    }

    if(is != null) {
      Toolkit tk = Toolkit.getDefaultToolkit();

      try {
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        int c = is.read();
        while (c != -1) {
          os.write(c);
          c = is.read();
        }

        is.close();
        os.close();

        Image image = tk.createImage(os.toByteArray());

        if(image != null) {
          return new ImageIcon(image);
        }
      }
      catch(IOException e) {
        e.printStackTrace();
      }
    }

    return null;
  }

  public static ImageIcon getImageIcon(String archiveName, String iconFileName) {
    if(isJava2Version) {
      try {
        URL url =  new URL("jar:file:" + archiveName + "!" + iconFileName);

        return new ImageIcon(url);
      }
      catch(IOException e) {
        e.printStackTrace();
      }
    }

    return null;
  }

}

